<template>
  <div class="q-pa-md q-gutter-sm">
    <q-dialog v-model="toolbar">
      <q-card>
        <q-toolbar>
          <q-space />
          <q-btn color="purple" round dense icon="close" v-close-popup />
        </q-toolbar>
        <q-card-section>
          <AddPayments />
        </q-card-section>
      </q-card>
    </q-dialog>
  </div>

  <q-dialog v-model="confirm" persistent>
    <q-card>
      <q-card-section class="row items-center">
        <q-avatar icon="priority_high" color="red" text-color="white" />
        <span class="q-ml-sm"
          >Esta seguro de eliminar el id: {{ idelim }} ?</span
        >
      </q-card-section>

      <q-card-actions align="right">
        <q-btn flat label="Cancelar" color="red" v-close-popup />
        <q-btn
          flat
          label="Confirmar"
          color="primary"
          @click="eliminar(idelim)"
          v-close-popup
        />
      </q-card-actions>
    </q-card>
  </q-dialog>

  <!--   <pre>{{ data }}</pre> -->
  <div class="q-pa-md">
    <q-btn
      class="q-mb-md"
      round
      color="purple"
      icon="add"
      @click="toolbar = true"
    />

    <q-table
      title="Lista Medios de pagos"
      :rows="rows"
      :columns="columns"
      row-key="id"
      :filter="filter"
      binary-state-sort
    >
      <template v-slot:top>
        <div class="col-2 q-table__title">Medios de pago</div>
        <q-space />
        <q-input
          borderless
          dense
          debounce="300"
          v-model="filter"
          placeholder="Search"
        >
          <template v-slot:append>
            <q-icon name="search" />
          </template>
        </q-input>
      </template>
      <template v-slot:header="props">
        <q-tr :props="props">
          <q-th auto-width />
          <q-th v-for="col in props.cols" :key="col.name" :props="props">
            {{ col.label }}
          </q-th>
        </q-tr>
      </template>
      <template v-slot:body="props">
        <q-tr :props="props">
          <q-td auto-width>
            <q-btn
              size="sm"
              round
              color="red"
              glossy
              @click="(confirm = !confirm), (idelim = props.key)"
              icon="delete"
            />
          </q-td>

          <q-td key="id" :props="props">
            {{ props.row.id }}
            <!--      <q-popup-edit v-model="props.row.id" v-slot="scope">
              <q-input v-model="scope.value" dense autofocus counter />
            </q-popup-edit> -->
          </q-td>

          <q-td key="kind" :props="props">
            {{ props.row.kind }}
            <q-popup-edit
              v-model="props.row.kind"
              v-slot="scope"
              title="Tipo"
              buttons
              label-set="Guardar"
              label-cancel="Cancelar"
              @save="
                (v, iv) => {
                  save(v, iv, props.key, 'tipo');
                }
              "
            >
              <q-input type="text" v-model="scope.value" dense autofocus />
            </q-popup-edit>
          </q-td>
        </q-tr>
      </template>
    </q-table>
  </div>
</template>

<script>
import { api } from "boot/axios";
import { ref, onMounted } from "vue";
import { useQuasar, SessionStorage } from "quasar";
import AddPayments from "./AddPayments.vue";

const columns = [
  {
    name: "id",
    required: true,
    label: "Id",
    align: "left",
    field: (row) => row.name,
    format: (val) => `${val}`,
    sortable: true,
  },
  {
    name: "kind",
    align: "center",
    label: "Tipo Medio",
    field: "kind",
    sortable: true,
  },
];

export default {
  setup() {
    const $q = useQuasar();
    const token = SessionStorage.getItem("jwt");
    const data = ref([]);
    function returnPayments() {
      api
        .get("mediosPago", {
          headers: {
            accept: "application/json",
            Authorization: token,
          },
        })
        .then((response) => {
          /* console.log("datos " + JSON.stringify(response.data.data)); */
          data.value = response.data.data;
          //    return JSON.stringify(response.data.data);
        })
        .catch((error) => {
          $q.notify({
            color: "negative",
            position: "bottom",
            message: `code: ${error.response.status} - Mensaje ${error}`,
            icon: "report_problem",
          });
          /* } */
          console.log(error);
        });
    }
    onMounted(() => {
      returnPayments();
    });
    return {
      filter: ref(""),
      save(value, initialValue, id, field) {
        const payments = `{ "${field}": "${value}"  }`;
        api
          .put(`mediosPago/${id}`, JSON.parse(payments), {
            headers: {
              accept: "application/json",
              Authorization: token,
            },
          })
          .then((response) => {
            console.log(`payments actualizado `);
            $q.notify({
              color: "positive",
              position: "bottom",
              message: `Se guardo el campo: ${field} con el nuevo valor ${value} correctamente`,
              icon: "mood",
            });
          })
          .catch((error) => {
            console.log(`payments no actualizado ${error}`);
            $q.notify({
              color: "negative",
              position: "bottom",
              message: `Mensaje ${error}`,
              icon: "report_problem",
            });
          });
      },
      eliminar(id) {
        console.log(`url usuarios/${id}`);
        api
          .delete(`mediosPago/${id}`, {
            headers: {
              accept: "application/json",
              Authorization: token,
            },
          })
          .then((response) => {
            console.log(`Registro eliminado`);
            $q.notify({
              color: "positive",
              position: "bottom",
              message: `Se elimino el usuario id: ${this.idelim.value} correctamente`,
              icon: "mood",
            });
            returnPayments();
          })
          .catch((error) => {
            $q.notify({
              color: "negative",
              position: "bottom",
              message: `Mensaje ${error}`,
              icon: "report_problem",
            });
          });
      },
      columns,
      rows: ref(data),
      data,
      confirm: ref(false),
      verProduct: ref(false),
      toolbar: ref(false),
      idelim: ref(0),
      sendProduct: ref([]),
    };
  },
  components: { AddPayments },
};
</script>
